#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <string>
#include <cstring>
#include <fmi2Functions.h>
#include <fmi2FunctionTypes.h>
#include <iostream>
#include <jni.h>
#include <fstream> 
#include <ctime>
#include <chrono>
using namespace std;




int main(int argc, char **argv) {


    /** Start of monitor instantiate **/
    
    JavaVM *jvm;       /* denotes a Java VM */
    JNIEnv *env;      
    JavaVMInitArgs vm_args; /* JDK/JRE VM initialization arguments */
    JavaVMOption* options = new JavaVMOption[1];
    options[0].optionString = "-Djava.class.path=/usr/lib/java:/home/siemens/dejavu/dir/dejavu.jar:/usr/share/scala-2.11/lib/scala-library.jar :/home/siemens/dejavu/out/examples/speedlimit/TraceMonitor.jar";
    vm_args.version = JNI_VERSION_1_6;
    vm_args.nOptions = 1;
    vm_args.options = options;
    vm_args.ignoreUnrecognized = false;

    /* load and initialize a Java VM, return a JNI interface
    * pointer in env */
    JNI_CreateJavaVM(&jvm, (void**)&env, &vm_args);

    // First get the class that contains the method you need to call
    jclass tracemonitor_class = env->FindClass("TraceMonitor");

    // Get the method that you want to call
    jmethodID main_method = env->GetStaticMethodID(tracemonitor_class, "eval", "(Ljava/lang/String;)Z");
    
    /** End of monitor instantiate **/

    int ret = EXIT_SUCCESS;
    fmi2Real tstart = 0.0;
    fmi2Real tcur = tstart;
    fmi2Real hstep = 0.1;
    fmi2Real tend = 300.0;
    void *handle_p, *handle_c;
  
    fmi2InstantiateTYPE* (fmi2InstantiateController);
    fmi2EnterInitializationModeTYPE* (fmi2EnterInitializationModeController);
    fmi2ExitInitializationModeTYPE* (fmi2ExitInitializationModeController);
    fmi2SetRealTYPE* (fmi2SetRealController);
    fmi2GetRealTYPE* (fmi2GetRealController);
    fmi2DoStepTYPE* (fmi2DoStepController);
    void (*set_inverted_map_controller)(int,string);


    fmi2InstantiateTYPE* (fmi2InstantiatePlant);
    fmi2EnterInitializationModeTYPE* (fmi2EnterInitializationModePlant);
    fmi2ExitInitializationModeTYPE* (fmi2ExitInitializationModePlant);
    fmi2SetRealTYPE* (fmi2SetRealPlant);
    fmi2GetRealTYPE* (fmi2GetRealPlant);
    fmi2DoStepTYPE* (fmi2DoStepPlant);
    void (*set_inverted_map_plant)(int,string);

    char *error;
    handle_c = dlopen ("controller/binaries/linux64/controller.so", RTLD_LAZY);
    if (!handle_c) {
        fprintf (stderr, "%s\n", dlerror());
        exit(1);
    }
    dlerror();    /* Clear any existing error */
   
    handle_p = dlopen ("plant/binaries/linux64/plant.so", RTLD_LAZY);
    if (!handle_p) {
        fprintf (stderr, "%s\n", dlerror());
        exit(1);
    }
    dlerror();    /* Clear any existing error */
    
    fmi2InstantiateController = (fmi2InstantiateTYPE*) dlsym(handle_c, "fmi2Instantiate");
    fmi2EnterInitializationModeController = (fmi2EnterInitializationModeTYPE*) dlsym(handle_c, "fmi2EnterInitializationMode");
    fmi2ExitInitializationModeController = (fmi2ExitInitializationModeTYPE*) dlsym(handle_c, "fmi2ExitInitializationMode");
    fmi2SetRealController = (fmi2SetRealTYPE*) dlsym(handle_c, "fmi2SetReal");
    fmi2GetRealController = (fmi2GetRealTYPE*) dlsym(handle_c, "fmi2GetReal");
    fmi2DoStepController = (fmi2DoStepTYPE*) dlsym(handle_c, "fmi2DoStep");
    set_inverted_map_controller = (void (*)(int, std::string)) dlsym(handle_c, "set_inverted_map");


    fmi2InstantiatePlant = (fmi2InstantiateTYPE*) dlsym(handle_p, "fmi2Instantiate");
    fmi2EnterInitializationModePlant = (fmi2EnterInitializationModeTYPE*) dlsym(handle_p, "fmi2EnterInitializationMode");
    fmi2ExitInitializationModePlant = (fmi2ExitInitializationModeTYPE*) dlsym(handle_p, "fmi2ExitInitializationMode");
    fmi2SetRealPlant = (fmi2SetRealTYPE*) dlsym(handle_p, "fmi2SetReal");
    fmi2GetRealPlant = (fmi2GetRealTYPE*) dlsym(handle_p, "fmi2GetReal");
    fmi2DoStepPlant = (fmi2DoStepTYPE*) dlsym(handle_p, "fmi2DoStep");
    set_inverted_map_plant = (void (*)(int, std::string)) dlsym(handle_p, "set_inverted_map");

    if ((error = dlerror()) != NULL)  {
        fprintf (stderr, "%s\n", error);
        exit(1);
    }
    
    cout<<"CALL fmi2Instantiate...\n";
    
    fmi2Component c_controller = (*fmi2InstantiateController)("prModel", fmi2CoSimulation , "prModel", "resource/location", NULL, true, true);
    
    (*set_inverted_map_controller)(100, "ROOT.environment._id__inputIndex");
    //(*set_inverted_map)(101, "ROOT.environment._id__time");
    (*set_inverted_map_controller)(101, "ROOT.camera._id__inputIndex");
    (*set_inverted_map_controller)(102, "ROOT.perception._id__result_buffer");
    (*set_inverted_map_controller)(103, "ROOT.perception._id__inputIndex");
    (*set_inverted_map_controller)(104, "ROOT.perception._id__result");
    (*set_inverted_map_controller)(105, "ROOT.controller._id__speed");
    (*set_inverted_map_controller)(106, "ROOT.controller._id__speedLimit");
    (*set_inverted_map_controller)(107, "ROOT.controller._id__deltaSpeed");
    (*set_inverted_map_controller)(108, "ROOT.controller._id__zero");
    
    fmi2Component c_plant = (*fmi2InstantiatePlant)("prModel", fmi2CoSimulation , "prModel", "resource/location", NULL, true, true);
    
    (*set_inverted_map_plant)(109, "ROOT.brake._id__deltaSpeed");
    (*set_inverted_map_plant)(110, "ROOT.throttle._id__deltaSpeed");
    (*set_inverted_map_plant)(111, "ROOT.speedSensor._id__speed");
    (*set_inverted_map_plant)(112, "ROOT.speedSensor._id__deltaSpeed");
    
    const unsigned int vr_controller[] = {100,101,102,103,104,105,106,107,108};
    const unsigned int vr_plant[] = {109,110,111,112};

    fmi2Real values_controller[] = {1,0,0,0,0,100,110,0,0};
    fmi2Real values_plant[] = {0,0,100,0};
    
    cout<<"CALL fmi2SetReal of controller...\n";
    (*fmi2SetRealController)(c_controller, vr_controller, 9, values_controller);
    
    cout<<"CALL fmi2SetReal of plant...\n";
    (*fmi2SetRealPlant)(c_plant, vr_plant, 4, values_plant);

    cout<<"CALL fmi2EnterInitializationMode...\n";
    (*fmi2EnterInitializationModeController)(c_controller);
    (*fmi2EnterInitializationModePlant)(c_plant);

    cout<<"CALL fmi2ExitInitializationMode...\n";
    (*fmi2ExitInitializationModeController)(c_controller);
    (*fmi2ExitInitializationModePlant)(c_plant);
    
    tcur = tstart;
    fmi2Real result_buffer = 0;

    std::ofstream cent_times ("centralized_times.txt");
    std::ofstream cent_trace ("centralized_trace.txt");
    std::ofstream data ("centralized_data.txt");

    std::chrono::time_point<std::chrono::system_clock> start_while = std::chrono::system_clock::now();
    while(tcur<tend){
        std::chrono::time_point<std::chrono::system_clock> start_iteration = std::chrono::system_clock::now();
        fmi2Boolean newStep = fmi2True;
        fmi2Real val_controller[9];
        fmi2Real val_plant[4];

        cout<<"Current time step: "<<tcur<<'\n';
         
        //cout<<"CALL fmi2DoStep...\n";
        fmi2DoStepController(c_controller, tcur,hstep, newStep);

        //cout<<"CALL fmi2GetReal...\n";
        fmi2GetRealController(c_controller, vr_controller, 9, val_controller);
      //  cout<<"Speed:"<<val_controller[5]<<endl;
        cout<<"Speed Limit:"<<val_controller[6]<<endl;

        /* Synchronization between two fmus - send plant's speed to the controller
        one step after new traffic sign detection
         */

        if( val_controller[2] != result_buffer ) {

            fmi2Real val_plant_speed[1];
            const unsigned int vr_plant_speed[] = {111};
            const unsigned int vr_controller_speed[] = {105};
            cout<<"Send plant's speed to controller\n";
            result_buffer = val_controller[2];
            fmi2GetRealPlant(c_plant, vr_plant_speed, 1, val_plant_speed);
            fmi2SetRealController(c_controller, vr_controller_speed, 1, val_plant_speed);
        }

        /* Synchronization between two fmus - send deltaSpeed speed to the plant's throttle/break
        two steps after new traffic sign detection
         */
        else if ( val_controller[7] > 0) { 
            fmi2Real val_plant_speed[1];
            val_plant_speed[0] = val_controller[7];
            const unsigned int vr_plant_throttle[] = {110};
            fmi2SetRealPlant(c_plant, vr_plant_throttle, 1, val_plant_speed);
             
        }
        else if ( val_controller[7] < 0) {

            fmi2Real val_plant_speed[1];
            val_plant_speed[0] = val_controller[7];
            const unsigned int vr_plant_break[] = {109};
            fmi2SetRealPlant(c_plant, vr_plant_break, 1, val_plant_speed);
           
        }
       
        fmi2DoStepPlant(c_plant, tcur,hstep, newStep);
        fmi2GetRealPlant(c_plant, vr_plant, 4, val_plant);
        cout<<"Speed:"<<val_plant[2]<<endl;
        data<<val_controller[6]<<","<<val_plant[2]<<"\n";
        string nativeString;

        /* Synthesize current event */
        std::chrono::time_point<std::chrono::system_clock> start_synthesize = std::chrono::system_clock::now();
        nativeString+="speed";
        nativeString+=",";
        nativeString+=to_string((int) (val_controller[6] * 1000000));
        nativeString+=",";
        nativeString+=to_string((int) (val_plant[2] * 1000000));
        std::chrono::time_point<std::chrono::system_clock> end_synthesize = std::chrono::system_clock::now();

        /* call monitor for evaluation */
        std::chrono::time_point<std::chrono::system_clock> start_monitor = std::chrono::system_clock::now();

        env->CallStaticBooleanMethod(tracemonitor_class, main_method, env->NewStringUTF(nativeString.c_str()));
        std::chrono::time_point<std::chrono::system_clock> end_monitor = std::chrono::system_clock::now();
        tcur += hstep;
        std::chrono::time_point<std::chrono::system_clock> end_iteration = std::chrono::system_clock::now();

        cent_times<<chrono::duration_cast<chrono::duration<float,std::milli>>(end_iteration - start_iteration).count() /*(end_iteration - start_iteration) / (double)(CLOCKS_PER_SEC)*/<< "," 
        << chrono::duration_cast<chrono::duration<float,std::milli>>(end_synthesize - start_synthesize).count() /*(end_synthesize - start_synthesize)/ (double)(CLOCKS_PER_SEC) */<< 
        "," << chrono::duration_cast<chrono::duration<float,std::milli>>(end_monitor - start_monitor).count() /*(end_monitor - start_monitor)/ (double)(CLOCKS_PER_SEC)*/ << '\n';
     }

    std::chrono::time_point<std::chrono::system_clock> end_while = std::chrono::system_clock::now();
    cent_trace<<"Total simulation loop time:" << chrono::duration_cast<chrono::milliseconds>(end_while - start_while).count() /*(end_while - start_while)/ (double)(CLOCKS_PER_SEC)*/<< 
        "," << "Number of iterations: " << tend/hstep << '\n';
    
    cout<<"Simulation finished.\n";

    dlclose(handle_c);
    dlclose(handle_p);
    cent_times.close();
    cent_trace.close();
    data.close();
    return ret;
}
